if 0
  % run under matlab 5
  a = rand(2,3);
  b = rand(3,4);
  c = rand(3);
  flops(0); a+a; flops
  flops(0); a.*a; flops
  flops(0); a./a; flops
  flops(0); a<a; flops
  flops(0); exp(a); flops
  flops(0); log(a); flops
  flops(0); a*a'; flops
  flops(0); a*b; flops
  flops(0); a/b'; flops
  
  ns = 1:10;
  f = [];
  for n = ns
    c = rand(n);
    c = c*c';
    flops(0); chol(c); f(n) = flops;
  end
  f = [1 5 14 30 55 91 140 204 285 385];
  x = [ones(size(ns)); ns; ns.^2; ns.^3];
  a = f/x
  plot(ns,f - a*x)
end

a = ones(100);
b = zeros(100);
tic; for i=1:1000 ones(100); end; t_ones=toc;
fprintf('time for ones: %g\n', t_ones);
t = [];
tic; for i=1:1000 a+4; end; t(1)=toc;
tic; for i=1:1000 a+b; end; t(2)=toc;
tic; for i=1:1000 a.*b; end; t(3)=toc;
t_arith = mean(t) - t_ones;
fprintf('average time for arithmetic ops: %g\n', t_arith);
% By time, == takes 2 flops, but this is processor dependent.
t = [];
tic; for i=1:1000 a<b; end; t(1)=toc;
tic; for i=1:1000 a>b; end; t(2)=toc;
tic; for i=1:1000 a==b; end; t(3)=toc;
tic; for i=1:1000 a~=b; end; t(4)=toc;
t_rel = mean(t) - t_ones;
fprintf('average time for relops: %g\n', t_rel);
fprintf('equivalent flopcount = %g\n', t_rel/t_arith);
tic; for i=1:1000 randn(100); end; t=toc;
t = t-t_ones;
fprintf('time for randn: %g\n', t);
fprintf('equivalent flopcount = %g\n', t/t_arith);
tic; for i=1:1000 a.^(0.51); end; t=toc;
e1 = exp(1);
tic; for i=1:1000 e1.^a; end; t=toc;
t = t-t_ones;
fprintf('time for pow: %g\n', t);
fprintf('equivalent flopcount = %g\n', t/t_arith);
if 0
  tic; for i=1:1000 a.^(0.5); end; toc
  tic; for i=1:1000 sqrt(a); end; toc
end
t = [];
tic; for i=1:1000 exp(a); end; t(1)=toc;
tic; for i=1:1000 log(a); end; t(2)=toc;
t_exp = mean(t) - t_ones;
fprintf('average time for exp/log: %g\n', t_exp);
fprintf('equivalent flopcount = %g\n', t_exp/t_arith);
